# GPXLoad: Resource manager

**GPX file Import / Export** and Resource management for **Signal K Server**.

- Import Routes and Waypoints from GPX files to SignalK server.

- Export Route and Waypoint resources from Signal K server to a GPX file, preserving their UUIDs, in order to avoid resource duplication if re-imported.

- Preview Signal K resources and GPX file contents on a map.

---
### __Note -__ GPXLoad no longer acts as a resource provider for the following paths:

```
./resources/routes

./resources/waypoints

./vessels/self/navigation/courseGreatCircle/activeRoute/href

./vessels/self/navigation/courseGreatCircle/activeRoute/startTime

./vessels/self/navigation/courseGreatCircle/nextPoint/position

./vessels/self/navigation/courseGreatCircle/nextPoint/bearingTrue
```

To service these paths you will need to have an appropriate plugin installed on the Signal K server:

- `Routes` and `Waypoints`: A resource provider such as [sk-resource-fs](https://www.npmjs.com/package/sk-resources-fs) should be used. 

    _Note: `sk-resource-fs` will enable you to continue using your existing routes and waypoints, just enter path to your exisiting resources in the configuration._

- `Course data`: The Freeboard Helper plugin [freeboard-sk-plugin](https://www.npmjs.com/package/freeboard-sk-plugin) can be used as a provider for `activeRoute` and `nextPoint` paths. 

---

## Operation:

**To Import a GPX file:**

1) Select the **Import GPX** and click **Open GPX file** 

1) Select a GPX file.

1) Select the Routes and / or Waypoints from the displayed list. 
_Note: Listed Tracks can be previewed only as Signal K specification does not define Track resources at this time._

1) To import just selected resources of a particular type click the **Load** button located within that resources group. To import all selected resources click **Load** button at the top of the screen.

--- 
**To Export resources to a GPX file:**

1) From the main screen, select the Routes and / or Waypoints from the list that you want saved to the GPX file.

1) Click the **Save** button and select a destination file name.

1) Selected resources are exported to the GPX file. 


**Note:** 

- Clicking **Refresh** will reload the resource list from the Signal K server.

- GPXLoad preserves the uuids of resources exported from Signal K server in the GPX file, so if these GPX files are re-imported they will update the corresponding resource on the Signal K server rather than create a new resource.

- GPX files containing elements without Signal K UUID values will have UUIDs assigned each time the file is opened (or re-opened) in the WebUI. This will result in duplicate resources on the Signal K server if a GPX file is: opened, resources imported, re-opened and the same resources imported.

--- 
**To Delete resources from the Server:**

1) From the main screen, select the Routes and / or Waypoints from the list that you want to the delete.

1) Click the **Delete** button.

1) You will be prompted to _Confirm_ the deletion of the selected resources. Click __Delete__ to remove them from the server.

---
